function [M,K,Fext,U0,Up0]=assemblage(L,S,E,rho,ne,F,t,tl)
% Assemblage des matrices masses et raideur du systeme, conditions
% initiales et vecteur force

disp('======== Assemblage des matrices masse et raideur ========')
disp('Assemblage en cours ...')
tic;

le=L/ne;   % Longueur d'un element

% % Assemblage de la matrice masse
% M=diag(2*ones(ne+1,1),0)+diag(ones(ne,1),1)+diag(ones(ne,1),-1);
% for i=2:ne
%     M(i,i)=M(i,i)+2;
% end
% M=((rho*S*le)/6)*M;

% % Assemblage de la matrice raideur
% K=diag(ones(ne+1,1),0)+diag(-ones(ne,1),1)+diag(-ones(ne,1),-1);
% for i=2:ne
%     K(i,i)=K(i,i)+1;
% end
% K=((E*S)/le)*K;
% K(end,end)=10*K(end,end);
% 
% % Matrice des forces exterieures
% Fext=zeros(ne+1,length(t));
% Fext(1,:)=-F*(t<=tl); % Chargement applique sur le premier noeud, tant que t<tl
% 
% % Conditions initiales
% U0=zeros(ne+1,1);
% Up0=zeros(ne+1,1);

% Assemblage de la matrice masse
M=diag(2*ones(ne,1),0)+diag(ones(ne-1,1),1)+diag(ones(ne-1,1),-1);
for i=2:ne
    M(i,i)=M(i,i)+2;
end
M=((rho*S*le)/6)*M;

% M=diag(ones(ne,1),0);
% for i=2:ne
%     M(i,i)=M(i,i)+1;
% end
% M=((rho*S*le)/2)*M;

% Assemblage de la matrice raideur
K=diag(ones(ne,1),0)+diag(-ones(ne-1,1),1)+diag(-ones(ne-1,1),-1);
for i=2:ne
    K(i,i)=K(i,i)+1;
end
K=((E*S)/le)*K;

% Matrice des forces exterieures
Fext=zeros(ne,length(t));
Fext(1,:)=-F*(t<=tl); % Chargement applique sur le premier noeud, tant que t<tl

% Conditions initiales
U0=zeros(ne,1);
Up0=zeros(ne,1);

time=toc;
disp(['Assemblage effectu! Temps coul: ' num2str(time) ' s']); disp(' ')

end