close all
clear all

% Definition des parametres de la simulation

% Duree de la simulation
T=10;

% Choix du pas de temps
dt=0.01;

% Creation du vecteur des instants ou la solution sera calcule
t=0:dt:T;

% Parametres de l'algorithme de Newmark
% Parametres de l'algorithme de Newmark
a=0;
beta=0.25*(1+a)^2;
gamma=0.5+a;

% Matrice masse et raideur du systeme
M=[3];
K=[30];

%Matrice des forces exterieures a chaque instant t
F=zeros(size(t));

% Conditions intitiales
U0=[1];
Up0=[0];

% Resolution du probleme
[U,Up]=newmark2(M,K,F,U0,Up0,beta,gamma,t,dt);

% Calcul de la solution analytique
[Uex,tex]=sol_ressort(M,K,U0,Up0,T,t,U,Up);





